## Background
This project is a summary of the author's years of study and work practice.   
Most of the code has been actually run to ensure accuracy.   
    
本项目是作者多年学习与工作实践的总结，绝大部分代码都经过实际运行保证准确无误  

## Structure

```
  -- bigdata               solution for bigdata，contains hive/hadoop/spark/hbase etc... 
  -- code-languages        programming language，contains java/python/scala etc...  
  -- cs-other              some interesting things in the cs field    
  -- deep-learning         derivation of some algorithm principles of deep learning，tensorflow frame etc...    
  -- feature-engineering   feature-engineering is very important for algorithm
  -- math                  mathematical principles，contains matrix analysis, probability and statistics etc...
  -- mathcasebycase        some mathematical knowledge points that are relatively scattered and difficult to classify 
  -- recommend             knowledge about recommendation system  
  -- service-enginnering   service online，essential knowledge for algorithm online  
  -- tools                 various tools commonly used in practice, 
                           including awk, grep, sed data processing three swordsmen, 
                           git, maven and other common tools, intellij,
                           sublime, vim and other IDEs, 
                           linux-shell common scripts
  -- traditional-algorithm traditional machine learning algorithms that are different from deep learning,
                           including clustering algorithms/optimization methods/tree algorithms, etc.,
                           as well as a brief introduction to mllib.

```  

```
  -- bigdata               大数据处理方案，包括hive/hadoop/spark/hbase等  
  -- code-languages        编码语言，包括java/python/scala等  
  -- cs-other              cs领域的一些有意思的事情  
  -- deep-learning         深度学习的一些算法原理推导，tensorflow等框架  
  -- feature-engineering   特征工程，做过算法的人都知道特征工程重要性  
  -- math                  数学原理，包括矩阵分析，概率统计等算法中常用数学知识  
  -- mathcasebycase        一些比较分散不好归类的数学知识点  
  -- recommend             推荐系统一些相关知识，目前作者就从事推荐相关工作  
  -- service-enginnering   线上服务，算法上线必备知识  
  -- tools                 实际中常用的各种工具，包括awk,grep,sed数据处理三剑客，git,maven等常见工具，
                           intellij，sublime,vim等IDE, linux-shell常见脚本  
  -- traditional-algorithm 区别于深度学习的传统机器学习算法，包括聚类算法/最优化方法/树类算法等，
                           还有mllib的简单介绍。  
```  

## Suitable for
### for computer science guys
The author come from a non-CS major,   
and did not systematically study data structures, operating systems,   
design patterns and other courses during school.   
The relevant knowledge is to be studied systematically after work.    
So this project is especially suitable for non-CS majors.    
    
作者非CS专业科班出身，在校期间并未系统学习过数据结构,操作系统,设计模式等课程，    
相关的知识都是工作以后再进行系统学习。  
所以该项目特别适合非CS专业同学参考。  

###  for non-computer science guys
For CS majors, some of them have not studied mathematics courses systematically,     
such as matrix analysis, probability statistics, optimization, etc.   
The major of the author's master's degree is pattern recognition.   
And in the future work, he roughly understand which mathematical knowledge  
is the key and difficult point in algorithm learning and practice.  
Therefore, this project is also suitable for students majoring in CS  
  
CS专业的同学，有一部分没有系统学过数学方面的课程，比如矩阵分析，概率统计，最优化等。  
作者硕士阶段所学专业为模式识别，在以后的工作中，  
大致了解哪些数学知识是算法学习与实践中的重点与难点。  
因此，该项目也特别适合CS专业的同学。 


### for guys who need to put the algorithm online from 0 to 1
The algorithm is not just an offline train model,     
it can even be said that the offline train model is only a small part of the work.   
On the contrary, the corresponding engineering capabilities,   
code capabilities, and data capabilities are very important.    
Therefore, this project is especially suitable for guys   
who need to put the algorithm online from 0 to 1.  
      
算法并不只是离线train model，甚至可以说离线train model只是工作很小的一部分。  
相反对应的工程能力，代码能力，数据能力非常重要。    
因此该项目特别适合需要将算法从0到1怼上线的同学    


### for guys who need to solve various practical problems in actual work
The project not only contains algorithm theory, algorithm derivation,   
but also more engineering and data aspects.  
Most of them are actual problems encountered in work,   
which can provide you with reference ideas in practice.    
Therefore, this project is especially suitable for guys   
who need to solve various practical problems in actual combat.    
    
该项目不仅有算法理论，算法推导，还有更多工程以及数据方面的内容，  
大部分都是工作中遇到的实际问题，可以为大家实践中提供参考思路。      
因此该项目特别适合实战中需要解决各种实际问题的同学    

## CSDN address
https://blog.csdn.net/bitcarmanlee  

## Update
The layout and stability of github is higher than that of csdn.  
In the future, it will be prioritized to maintain the projects on github,  
and csdn will also keep synchronized updates.   
  
github的排版以及稳定性比csdn更高，以后优先维护github上的项目，CSDN也会保持同步更新。        
