## 1.匿名函数初探
Scala 中定义匿名函数的语法很简单，箭头左边是参数列表，右边是函数体，参数的类型是可省略的，Scala 的类型推测系统会推测出参数的类型。使用匿名函数后，我们的代码变得更简洁了。  


```
val numIncOne = (x:Int) => x + 1
```  

上面的表达式就定义了一个接受一个Int类型输入参数的匿名函数，使用起来也很简单  

```
numIncOne(2)
```  

## 2.输入为空的匿名函数

```
val printFun = () => println("It's print function!")
```  

调用：  

```
printFun()
```  

上面的匿名函数没有接受任何参数，就是打印了一行字符串而已。  
需要注意的是，匿名函数的返回值的数据类型依赖于函数体的最后一行表达式的值，这个由程序自己判断，匿名函数的返回值类型不能手工指定！  


## 3.匿名函数的使用场景
1.函数变量(常量)  
像我们前面举的例子里，都把匿名函数保存为了一个常量。  

2.在将一个匿名函数作为参数进行传递。这个在我们平时编码过程中使用极多，因为scala是函数式编程语言，函数是头等公民，函数经常需要作为参数传递。如果给每个函数，尤其是那种一次性使用的函数起个合适的名字，那简直要头疼死了。在这种情况下，匿名函数就是最佳选择。来看几个特别简单的例子：  

```
val rawList = List(1,2,3,4,5,6)
println(rawList.filter(_>3)) //取大于3的数
println(rawList.map(x => x*2)) //将所有数乘2
```
