矩阵有时候有一些常用的结论与性质，如果有一段时间不接触或者实际中没使用到，很容易就会遗忘。因此，特意做一个小小的总结，方便使用与查询。  

1.矩阵$A$的全部特征值的集合通常被称为$A$的谱。  
2.$|A| = \lambda_1\lambda_2\cdots\lambda_n$，或者时候$A$的行列式为所有特征值的乘积。  
  
3.$\sum_{i=1}^{n}a_{ii} = \sum_{i=1}^n \lambda_i$  
矩阵$A$的主对角线上的所有元素和$\sum_{i=1}^{n}a_{ii}$被称为矩阵的迹，记为$trA$。于是，上面的第3条又可以记为:  

4.$trA = \sum_{i=1}^n \lambda_i$  
5.矩阵$A$与$A^T$有相同的谱。  

6.如果$A$，$B$是两个n阶矩阵，若存在n阶可逆矩阵$P$，$P^{-1}AP = B$，则成$A$与$B$相似，记为$A \sim B$，$P$为$A$到$B$的相似变换矩阵。    

7.如果$A \sim B$，则:  
$$|\lambda I - B| = |\lambda I - P^{-1}AP| = |P^{-1}(\lambda I - A) P| = |\lambda I - A|$$  
由上易知，如果$A \sim B$，则矩阵$A$，$B$有相同的谱。  

8.n阶方阵$A$可以相似对角化的充要条件是$A$有n个线性无关的特征向量。  

9.$A$为n阶方阵，$A$的特征多项式为:  
$$det(\lambda I - A) = (\lambda - \lambda_1)^{m_1}(\lambda - \lambda_2)^{m_2}\cdots(\lambda - \lambda_s)^{m_s}$$  

其中，$m_i$均为正整数，$\sum_{i=1}^{s} = n$，$\lambda_1,\lambda_2,\cdots,\lambda_s$为$A$的不同特征值，$m_i$为特征值$\lambda_i$的代数重数记为$p_i$。特征值$\lambda_i$对应的全部特征向量正好是特征方程组$(\lambda_i I - A)X = 0$的全部非0解。因此，$A$属于特征值$\lambda_i$的线性无关的特征向量最多有$n-r(\lambda_i I - A)$个，这个数也就是特征方程组$(\lambda_i I - A)X = 0$的一组基础解系中所含有解向量的个数，即解空间的位数，被称为特征值$\lambda_i$的几何重数，记为$q_i$。  

10.设$\lambda_1,\lambda_2,\cdots,\lambda_s$为$A$的全部互异的特征值，$p_i$，$q_i$分别为特征值$\lambda_i$的代数重数与几何重数，$i=1,2,\cdots,s$。则矩阵$A$可以相似对角化的虫咬条件是:  
$$p_i = q_i, i=1,2,\cdots,s$$  

11.实对称矩阵属于不同特征值的特征向量是正交的。  
12.$\lambda_0$是n阶实堆成矩阵$A$的任一特征值，p,q分别为它的代数重数与几何重数，有$p=q$。  

13.由前面一条结论可知，对任一n阶实对称矩阵$A$，存在n阶正交矩阵$Q$，有  
$$Q^{-1}AQ = diag(\lambda_1,\lambda_2,\cdots,\lambda_s)$$