## 1.线性相关(linearly dependent)与线性无关的(linearly independent)定义
线性相关的定义为：  
对于一组向量$v_1, v_2, \cdots, v_n$，如果存在一组不全为0的整数$k_1, k_2, \cdots, k_n$，使得$k_1v_1 + k_2v_2 + \cdots + k_nv_n = 0$成立，那么这组向量是线性相关的。如果只有当$k_1, k_2, \cdots, k_n$均为0时等式才成立，该向量组为线性无关的。    


## 2.简单理解
上面的定义不是特别好理解，下面我们换一种更容易理解的方式。  
如果有一组不全为0的数，那至少有一个数不为0，假设$k_n$不为0，那么该组向量线性相关。  
$$k_1v_1 + k_2v_2 + \cdots + k_nv_n = 0$$  
可以得知  
$$-k_1v_1 - k_2v_2 +-\cdots -k_{n-1}v_{n-1} = k_nv_n$$  

$$v_n = -\frac{k_1}{k_n}v_1-\frac{k_2}{k_n}v_2 - \cdots -\frac{k_{n-1}}{k_n}v_{n-1}$$  

不难看出，$v_n$可以由其他向量的线性组合表示，也就是说这个向量组是线性相关的。

## 3.实例
再举两个简单例子，$v_1 = (1, 0), v_2 = (0, 1)$，这就是我们熟悉的笛卡尔坐标系。如果要使得$k_1v_1 + k_2v_2=0$，必有$k_1=k_2=0$，因此这组向量线性无关。  

如果$v_1 = (1, 1), v_2 = (-1, -1)$，很明显$v_1 + v_2 = 0$，此时存在$k_1 = k_2 = 1$，使得$k_1v_1 + k_2v_2 = 0$，因此这组向量是线性相关的。  

## 4.一些结论
1.当向量组所含向量的个数与向量的维数相等，该向量组线性无关的充要条件为该向量构成的行列式值不为0。  
2.由该向量组构成的齐次方程组，如果该其次方程组有非零解，则该向量组线性相关。如果该方程组只有零解，则该向量组线性无关。  
3.若向量组的秩等于向量的个数，则该向量组是线性无关。如果秩小于向量的个数，则该向量组线性相关。  
4.若向量组所含向量的个数多于向量的维数，该向量组一定线性相关。  