## 1.普通正态分布转换标准正态分布公式
我们知道正态分布是由两个参数$\mu$与$\sigma$确定的。对于任意一个服从$N(\mu, \sigma^2)$分布的随机变量$X$，经过下面的变换以后都可以转化为$\mu=0, \sigma=1$的标准正态分布(standard normal distribution)。转换公式为:  
$$z = \frac{X-\mu}{\sigma}$$  

## 2.证明
概率统计的教科书上一般直接给出这个结论，并没有给出相应的证明。下面我们来看看这个结论的推理过程。由于犯懒懒得编辑公式，直接贴截图，证明过程来自参考文献1。  
![在这里插入图片描述](https://github.com/bitcarmanlee/easy-algorithm-interview-photo/blob/master/math/probability/gaussian_dist/1.png)  
![在这里插入图片描述](https://github.com/bitcarmanlee/easy-algorithm-interview-photo/blob/master/math/probability/gaussian_dist/2.png)  

## 3.几个应用的例子
3.1 假设公共汽车门的高度按成年男性碰头机会小于1%来设计。又假设成年男性的身高服从正态分布$X \sim N(170, 6^2)$，求问车门的高度$h$为多少?  

假设身高这一随机变量为$X$，那么要求的问题为:  
$$P(x > h) = 0.01$$  
即  
$$1 - P(x \le h) = 0.01$$  
$$P(x \le h) = 0.99$$  

因为$X \sim N(170, 6^2)$, 所以$\frac{h - 170}{6} \sim N(0, 1)$。  
通过查标准正态分布表可知,$P(z \le 2.33) = 0.99$  
因此h = 170 + 6 * 2.33 = 183.98cm  

3.2 现在有一个$\mu = 10$和$\sigma = 2$的正态随机变量，求x在10与14之间的概率是多少？  
当x=10时，z = 0。当x=14时，z = (14-10)/2 = 2。于是，x在10与14之间的概率等价于标准正态分布中0与2之间的概率。  
$$P(0 \le z \le 2) = P(z \le 2) - P(z \le 0) = 0.4772$$  

参考文献：  
1.https://www.zhihu.com/question/30121927  