## 1.初见泊松分布
Poisson distribution，翻译成中文名为泊松分布、普阿松分布、帕松分布、布瓦松分布、布阿松分布、波以松分布、卜氏分配等，是概率与统计学中一种常见的离散概率分布，常用来描述单位时间内随机时间发生次数的概率分布。  

若随机变量$X$服从参数为$\lambda$的泊松分布，则可以记为$X \sim \pi(X)$，或者$X \sim P(X)$。其中，参数$\lambda$是单位时间内随机事件$X$ 发生的平均概率。  

## 2.从二项分布到泊松分布
博主当年上大学的时候，因为学习不是很认真，一直没用弄明白泊松分布这分布还有那分布到底是个什么鬼。这里咱们先给出一个结论：泊松分布是二项分布的极限情况。具体推导过程，且看下面咱们的解释。  

先看看咱们最熟悉的二项分布。说到二项分布，自然就以抛硬币为例。假设我们抛4次硬币，$P(x)$表示有$x$次硬币正面朝上，二项分布的概率为：  
$p(0) = \frac {C_4^0}{2^4} = \frac{1}{16}$，$p(1) = \frac {C_4^1}{2^4} = \frac{4}{16}$，$p(2) = \frac {C_4^2}{2^4} = \frac{6}{16}$  

$p(3) = \frac {C_4^3}{2^4} = \frac{4}{16}$，$p(4) = \frac {C_4^4}{2^4} = \frac{1}{16}$  

上面的计算也很简单，无需过多解释。不过需要提及的一点是，二项分布中的随机变量$X$是离散变量，如果是连续变量呢？就该轮到我们的泊松分布登场了。  


举一个泊松分布中常用的例子。假设我们现在要估计某个路口一小时经过$k$辆车的概率。那么第一步，肯定是先大量观察一段时间，获取一小时的时间内通过的汽车数量的期望$\lambda$。例如连续三天的14：00-17：00都在路口观察，得到最终的期望值$\lambda$。然后我们把每小时分为60min。同时，还假设每分钟的时间间隔内，要么经过一辆车，要么没有车。根据咱们上面的二项分布，很容易得出以下概率：  

$$p(k) = C_{60}^k\frac{\lambda}{60}(1-\frac{\lambda}{60})^{60-k}$$  

其中，$\frac{\lambda}{60}$表示每分钟都有一辆车经过的概率。  

很明显，实际情况中，并不是真的每分钟只有一辆车经过，大路口每分钟有很多车经过是很正常的现象。那说明之前的假设不成立，怎么办呢？学过微积分的同学们都知道，很简单，继续分嘛。一分钟的精度如果不够，咱们分成半分钟；半分钟的精度如果还不够，分成一秒钟.....如果这么一直下去取极限，我们就得到了泊松分布，其实也就是二项分布的极限情况！  

写到这里为止，先将泊松分布的表达式给出：  
$$p(X=k) = \frac{e^{-\lambda} \lambda ^k}{k!}$$  

其中$\lambda$是单位时间内随机事件的平均发生率。  

## 3.泊松分布的推导  
在二项分布的伯努利试验中，如果试验次数n很大，二项分布的概率p很小，且乘积λ= np比较适中，则事件出现的次数的概率可以用泊松分布来逼近。事实上，二项分布可以看作泊松分布在离散时间上的对应物。  

证明：  
首先回顾$e$的定义:  
$$\displaystyle \lim _{n\to \infty }\left(1-{\lambda  \over n}\right)^{n}=e^{-\lambda }$$  

而二项分布的定义：  
$${\displaystyle P(X=k)={n \choose k}p^{k}(1-p)^{n-k}}$$  

如果令$p = \lambda / n$，有：  

$${\displaystyle {\begin{aligned}
\lim _{n\to \infty }P(X=k)&=\lim _{n\to \infty }{n \choose k}p^{k}(1-p)^{n-k}\\\\  
&=\lim _{n\to \infty }{n! \over (n-k)!k!}\left({\lambda  \over n}\right)^{k}\left(1-{\lambda  \over n}\right)^{n-k}\\\\
&=\lim _{n\to \infty }\underbrace {\left[{\frac {n!}{n^{k}\left(n-k\right)!}}\right]} _{F}\left({\frac {\lambda ^{k}}{k!}}\right)\underbrace {\left(1-{\frac {\lambda }{n}}\right)^{n}} _{\to \exp \left(-\lambda \right)}\underbrace {\left(1-{\frac {\lambda }{n}}\right)^{-k}} _{\to 1}\\\\
&=\lim _{n\to \infty }\underbrace {\left[\left(1-{\frac {1}{n}}\right)\left(1-{\frac {2}{n}}\right)\ldots \left(1-{\frac {k-1}{n}}\right)\right]} _{\to 1}\left({\frac {\lambda ^{k}}{k!}}\right)\underbrace {\left(1-{\frac {\lambda }{n}}\right)^{n}} _{\to \exp \left(-\lambda \right)}\underbrace {\left(1-{\frac {\lambda }{n}}\right)^{-k}} _{\to 1}\\\\
&=\left({\frac {\lambda ^{k}}{k!}}\right)\exp \left(-\lambda \right)
\end{aligned}}}$$  


看完上述推导过程以后，想必对泊松分布是二项分布的极限情况这个概念应该有更深入的了解。  

## 4.再看个实例
如果某个小商店，平均每周卖出两个水果罐头。问：该小商店水果罐头的最佳库存为多少？  
假定水果罐头的销量不存在季节性因素，可以近似认为满足下列条件：  
1.顾客购买水果罐头是小概率事件。  
2.顾客购买水果罐头是独立事件。  
3.顾客购买水果罐头的概率是平稳的，不会发生突变。  

在统计学上，只要某类事件满足以上三个条件，就可以认为它服从'泊松分布'。  

根据前面泊松分布的公式：  
$$p(X=k) = \frac{e^{-\lambda} \lambda ^k}{k!}$$  
具体到本例中：  
$P$：每周销售k个罐头的概率  
$X$：水果罐头的销售变量  
$k$：X的取值(0,1,2,3...)  
$\lambda$：每周水果罐头的销量，本例中为2  

有泊松分布的公式，可以计算得出每周销售的分布：  
![这里写图片描述](https://github.com/bitcarmanlee/easy-algorithm-interview-photo/blob/master/math/probability/poisson/1.png)  

从上表可见，如果存货4个罐头，95%的概率不会缺货（平均每19周发生一次）；如果存货5个罐头，98%的概率不会缺货（平均59周发生一次）。  

注：罐头的例子来自网络。找不到原始的出处了，所以没有给相应的来源信息。  

## 5.与伽马(gamma)分布的关系
伽马分布是概率统计的万人迷，到处都可以见到他的身影。咱们先看看伽马函数的定义：  
$${\displaystyle \Gamma (z)=\int _{0}^{\infty }{\frac {x^{z-1}}{\mathrm {e} ^{x}}}\,{\rm {d}}x}$$  
如果$z$为正整数，那么伽马函数可以定义为：  
$$\Gamma(n) = (n-1) !$$  

这就显示除了伽马函数与阶乘之间的联系。很明显可以看出，伽马函数将$n!$的计算扩展到了实数域与复数域。  

将上面的伽马函数做个简单处理，可以得到：  
$${\displaystyle \int _{0}^{\infty }{\frac {x^{\alpha-1} e^{-x} }{\mathrm {\Gamma(\alpha)}}}  \,{\rm {d}}x } = 1$$  

取上式中的函数作为概率密度，可以得到一个最简单的Gamma分布的密度函数：  
$$\Gamma(x|\alpha) = \frac {x^{\alpha-1} e^{-x} }{\mathrm \Gamma(\alpha)}$$  

对比一下我们之前的泊松分布：  
$$p(X=k) = \frac{\lambda ^k e^{-\lambda} }{k!}$$  

在Gamma分布中，如果令$\alpha = k + 1$，可以发现Gamma分布于泊松分布是完全一致的！  
所以，泊松分布于Gamma分布的区别在于，泊松分布是离散的，而Gamma分布是连续的，最直观的解释就是Gamma分布是泊松分布在正实数集上的连续化！  