最近在看某些文献的时候，有好几次都提到了数学危机，于是根据自己的理解，特意整理了一下关于三次数学危机的资料。

## 1.第一次数学危机
如果用一句简单的话概括第一次数学危机，可以描述为$\sqrt 2$危机。  

古希腊毕达哥拉斯学派是一个唯心主义学派。毕达哥拉斯学派认为，“万物皆数”(指整数)，数学的知识是可靠的、准确的，而且可以应用于现实的世界，数学的知识由于纯粹的思维而获得，不需要观察、直觉和日常经验。用比较简单的数学语言来描述就是：一个数都可以表示为另外两个数的比。但是，毕达哥拉斯的学生希帕索斯发现：等腰直角三角形的直角边与其斜边不可通约。现在我们都知道，等腰直角三角形的斜边就是$\sqrt 2$，而$\sqrt 2$并不是一个有理数，是一个无理数。因为当时毕达哥拉斯学派无法解释$\sqrt 2$的发现，希帕索斯被投入了大海。  
  
第一次数学危机对古希腊的数学观点产生了很大的冲击。危机表明，直觉和经验不一定靠得住，推理证明才是可靠的。从此古希腊人开始重视演绎推理，并建立起了几何公理体系。    

## 2.第二次数学危机
如果用一句简单的话概括第二次数学危机，可以描述为无穷小是零吗。  

随着近代数学尤其是天文学对数学的推动，微积分取得了巨大的成功。大家熟知的科学史上最牛逼闪闪的巨人之一牛顿，一生最伟大的三项成果之一就是微积分，而万有引力定律严格的数学表达式提出也是建立在牛顿牛逼闪闪的数学能力或者说是微积分能力基础之上。  
  
1734年，英国哲学家、大主教贝克莱发表《分析学家或者向一个不信正教数学家的进言》，矛头指向微积分的基础:无穷小的问题，提出了所谓贝克莱悖论。他认为无穷小dx既等于零又不等于零，召之即来，挥之即去，这是荒谬的。无穷小量究竟是不是零？无穷小及其分析是否合理？由此而引起了数学界甚至哲学界长达一个半世纪的争论，导致了数学史上的第二次数学危机。  

牛顿当时计算导数的过程类似如下：  

假设有函数$y = x ^ 2$，y在x=2处的导数为：  
$$\dot{y}=\frac{\Delta y}{\Delta x}=\frac{(2+ο)^2-2^2}{(2+ο)-2}=\frac{4+4ο+ο^2-4}{2+ο-2}=4+ο$$  
这里的$o$指非常小的一个量。按照牛顿的说法，因为这个量足够小我们最终可以忽略他。于是，为了计算$y = x ^ 2$的导数，先将x取某一不为0的增量$\Delta x$,然后计算y的增量：  
$$(x + \Delta x) ^ 2 - x ^ 2  = 2x\Delta x + {\Delta x} ^ 2$$  
将上面的式子除以$ \Delta x$，结果为$2x +  \Delta x$  
最要命的是，在牛顿的表述中，最后令$ \Delta x = 0$，得到导数为$2x$  

所以自相矛盾的地方就在于：在开始的时候，取了增量$ \Delta x$不为0，但是最后又令$ \Delta x = 0$。所以这么一来，大家就懵逼了...  

牛顿当时提出的微积分，其实是没有清楚定义无穷小的概念，因此导数，微分，积分，无穷大等基本概念都不清晰。直到19世纪20年代，一批又一批的数学家才开始比较关注微积分的严格数学基础与定义。中间经历了半个多世纪的努力，才基本解决了矛盾，为数学分析奠定了严格的数学基础。  


## 3.第三次数学危机
如果用一句简单的话概括第三次数学危机，可以描述为悖论危机。  
罗素在1901年为了比较形象地讲解罗素悖论给了一个例子：  
小城里的理发师放出豪言：他只为，而且一定要为，城里所有不为自己刮胡子的人刮胡子。  
但问题是：理发师该为自己刮胡子吗？如果他为自己刮胡子，那么按照他的豪言“只为城里所有不为自己刮胡子的人刮胡子”他不应该为自己刮胡子；但如果他不为自己刮胡子，同样按照他的豪言“一定要为城里所有不为自己刮胡子的人刮胡子”他又应该为自己刮胡子。  

用数学表达的方式来描述，可以表示为：$A={x|x ∉ A}$。那么此时，如果A∈A，们会推导出A∉A；反之如果说A∉A，那么我们会推导出A∈A。任何一个单方面的判断都会导致一个与之相悖的结论出现。  

罗素悖论一提出就在当时的数学界与逻辑学界内引起了极大震动。如G.弗雷格在收到罗素介绍这一悖论的信后伤心地说：“一个科学家所遇到的最不合心意的事莫过于是在他的工作即将结束时，其基础崩溃了。罗素先生的一封信正好把我置于这个境地。”戴德金也因此推迟了他的《什么是数的本质和作用》一文的再版。可以说，这一悖论就象在平静的数学水面上投下了一块巨石，而它所引起的巨大反响则导致了第三次数学危机。  

危机产生后，数学家纷纷提出自己的解决方案。人们希望能够通过对康托尔的集合论进行改造，通过对集合定义加以限制来排除悖论，这就需要建立新的原则。“这些原则必须足够狭窄，以保证排除一切矛盾；另一方面又必须充分广阔，使康托尔集合论中一切有价值的内容得以保存下来。”1908年，策梅罗在自已这一原则基础上提出第一个公理化集合论体系，后来经其他数学家改进，称为ZF系统。这一公理化集合系统很大程度上弥补了康托尔朴素集合论的缺陷。除ZF系统外，集合论的公理系统还有多种，如诺伊曼等人提出的NBG系统等。公理化集合系统的建立，成功排除了集合论中出现的悖论，从而比较圆满地解决了第三次数学危机。但在另一方面，罗素悖论对数学而言有着更为深刻的影响。它使得数学基础问题第一次以最迫切的需要的姿态摆到数学家面前，导致了数学家对数学基础的研究。而这方面的进一步发展又极其深刻地影响了整个数学。如围绕着数学基础之争，形成了现代数学史上著名的三大数学流派，而各派的工作又都促进了数学的大发展等等。（本段内容来自百度知道）