## 1.VPN
VPN的全名为 Virtual Private Network(虚拟私人网络)，是一种常用于连接中、大型企业或团体与团体间的私人网络的通讯方法。它利用隧道协议（Tunneling Protocol）来达到保密、发送端认证、消息准确性等私人消息安全效果，这种技术可以用不安全的网络（例如：互联网）来发送可靠、安全的消息。需要注意的是，加密消息与否是可以控制的，如果是没有加密的虚拟专用网消息依然有被窃取的危险。(参考文献1)  

很多人一提到VPN就会想起科学上网，其实VPN的初衷主要是用来做加密通讯用的，使用的是隧道协议。而隧道协议包括很多种，常见的有IPsec, PPTP, PPPoE等(参考文献2)。既然不是专门为科学上网设计的，那么VPN协议就会存在很多问题，最严重的一个就是流量特征非常明显，很容易被识别，相关的paper也有很多。所以目前来看，VPN已经不是科学上网的首选。  

## 2.VPS
VPS的全名为Virtual private server(虚拟专用服务器), 是将一台服务器分割成多个虚拟专享服务器的服务。实现VPS的技术分为容器技术和虚拟机技术。在容器或虚拟机中，每个VPS都可分配独立公网IP地址、独立操作系统、实现不同VPS间磁盘空间、内存、CPU资源、进程和系统配置的隔离，为用户和应用程序模拟出“独占”使用计算资源的体验。VPS可以像独立服务器一样，重装操作系统，安装程序，单独重启服务器。VPS为用户提供了管理配置的自由，可用于企业虚拟化，也可以用于IDC资源租用。(参考文献3)  

简单来说，VPS本质跟我们自己用的个人电脑差不多，区别在于其24小时对外提供服务，另外有会使用容器或者虚拟机等相关技术变成"好几台机器"，就好像我们也可以在自己的windows系统上再装个linux虚拟机。vps可以用来搭建网站，当然也可以用来当做vpn服务器，代理服务器，或者各种各样其他的服务器...  

## 3.Proxy
代理又分为正向代理与反向代理两种。  
### 3.1 正向代理
正向代理类似于一个跳板机，可以代理访问外部资源。在公司干过的同学一般都用过跳板机吧，自己的开发机一般来说是不能登录服务器的，需要先登录一个跳板机，通过账号密码验证什么的，再从这个跳板机登录服务器。  

我是一个用户，我访问不了某网站，但是我能访问一个代理服务器，这个代理服务器呢,他能访问那个我不能访问的网站，于是我先连上代理服务器,告诉他我需要那个无法访问网站的内容，代理服务器去取回来,然后返回给我。从网站的角度，只在代理服务器来取内容的时候有一次记录，有时候并不知道是用户的请求，也隐藏了用户的资料，这取决于代理告不告诉网站。  

![在这里插入图片描述](https://github.com/bitcarmanlee/easy-algorithm-interview-photo/blob/master/service/vpn/1.png)  
在正向代理中，Proxy与Client属于同一个网络，对server来说透明，server并不知道client的真实信息，只知道是从Proxy过来的请求。正向代理用途是为了在防火墙内的局域网提供访问internet的途径。另外还可以使用缓冲特性减少网络使用率。  

科学上网的本质就是正向代理。比如某用户A无法访问google，但是需求通过google去查一下资料，用户A能访问服务器B，服务器B可以访问google。是用户A访问服务器B，通过服务器B去访问google，，服务器B收到请求后，去访问google，google把响应信息返回给服务器B，服务器B再把响应信息返回给A。这样，通过代理服务器B，就实现了科学上网。  

### 3.2 反向代理

反向代理在电脑网络中是代理服务器的一种。服务器根据客户端的请求，从其关系的一组或多组后端服务器（如Web服务器）上获取资源，然后再将这些资源返回给客户端，客户端只会得知反向代理的IP地址，而不知道在代理服务器后面的服务器集群的存在[1]。  

与前向代理不同，前向代理作为客户端的代理，将从互联网上获取的资源返回给一个或多个的客户端，服务端（如Web服务器）只知道代理的IP地址而不知道客户端的IP地址；而反向代理是作为服务器端（如Web服务器）的代理使用，而不是客户端。客户端借由前向代理可以间接访问很多不同互联网服务器（集群）的资源，而反向代理是供很多客户端都通过它间接访问不同后端服务器上的资源，而不需要知道这些后端服务器的存在，而以为所有资源都来自于这个反向代理服务器。(参考文献4)  

![在这里插入图片描述](https://github.com/bitcarmanlee/easy-algorithm-interview-photo/blob/master/service/vpn/2.png)    

反向代理的作用非常多，比如  
保护和隐藏原始资源服务器  
加密和SSL加速  
负载均衡  
缓存静态内容  
压缩  
安全  
...  
等等  

举几个常见的例子：  
实际工作中，我们将某个服务发布以后，一般都会将服务发布到至少两个服务器上，以避免单点故障。在该层服务之前，我们一般都会再配置一层Nginx， Nginx就是最常用的一个反向代理，最重要的作用之一就是负载均衡，让该服务的流量平均分配到每台服务器上。  

另外，如果我们的服务有很多图片，视频等静态资源，有时候还会将这些资源放在CDN服务器上，用来缓存静态内容，解决因分布、带宽、服务器性能带来的访问延迟问题。    

在反向代理中，用户访问的实际上是反向代理服务器，并不知道真正提供的服务器是哪台。比如我们访问www.baidu.com，访问的其实是百度的反向代理服务器，反向代理服务器经过一系列的负载均衡等操作后面可能有成千上万台服务器真正为我们提供服务，但是对于用户来说这是透明的并不care。  


简单总结一下：  
正向代理是代理客户端，为客户端收发请求，使真实客户端对服务器不可见；而反向代理是代理服务器端，为服务器收发请求，使真实服务器对客户端不可见。  

## 4.DNS的工作流程
关于DNS是什么，相信有计算机基础的都或多或少了解一些，在此不多做解释。  
DNS的工作流程如下：  
1.当我们在地址栏中输入一个网址，并按下回车，域名解析的过程就开始了  
2.计算机首先会在查找本地的HOSTS文件，如果有的话，就直接引用HOSTS文件中的域名对应的ip地址，那么本次域名解析的过程就结束了。  
3.但是如果本地的HOSTS文件里没有对应的ip地址，那么就会看你的计算机有没有设置DNS服务器，如果没有设置，那么就没办法了，浏览器会报错，说网站的域名无法解析，本次解析过程就结束了。  
4.如果设置了DNS服务器，那么计算机就会那着我们输入的网址到那个DNS服务器去查找，如果去查找的DNS服务器的过程中有服务器挂掉了，那么还是没办法，浏览器还是会报错。  
5.如果没有错误，正常查询到了对应的ip，那么浏览器就会拿着这个ip地址来访问正常的web服务，本次解析过程结束。(参考文献5)  

## 5.DNS劫持
一个域名解析的过程就是送计算机得到域名到远端的DNS服务器把结果给我们返回过来，因此这个过程如果有一个中间人，他截获了我们的DNS请求，然后返回一个恶意的ip地址给我们，那么我们的计算机就会把这个恶意的ip地址当作我们想要访问的域名的对应ip，那么每次我们想访问这个网站的时候就会访问那个恶意的ip，如果那个中间人制作了一个和我们想要访问的网址一样的前端界面，就很有可能完成一次钓鱼攻击。  

比如前些年，很多地方的用户，尤其是那种小厂商的宽带用户，首次打开任何页面都指向ISP提供的“电信互联星空”、“网通黄页广告”等内容页面，这就是典型的DNS劫持现象。甚至还有过用户访问google的网站结果返回百度的页面，这也是DNS劫持现象。随着时代的进步，这种大规模的ISP层面的DNS劫持比较少见了，毕竟这样用户体验极差，而且属于违法行为。  


## 6.DNS污染
网域服务器缓存污染（DNS cache pollution），又称域名服务器缓存投毒（DNS cache poisoning）、DNS缓存投毒，是指一些刻意制造或无意中制造出来的域名服务器数据包，把域名指往不正确的IP地址。一般来说，在互联网上都有可信赖的网域服务器，但为减低网络上的流量压力，一般的域名服务器都会把从上游的域名服务器获得的解析记录暂存起来，待下次有其他机器要求解析域名时，可以立即提供服务。一旦有关网域的局域域名服务器的缓存受到污染，就会把网域内的电脑导引往错误的服务器或服务器的网址。  
域名服务器缓存污染可能是因为域名服务器软件的设计错误而产生，但亦可能由别有用心者透过研究开放架构的域名服务器系统来利用当中的漏洞。  
透过变更Windows 2003的某些域名数据包设置，可以摒除有可疑的数据包。[1]  
为防止局域的域名服务器缓存污染除了要定时更新服务器的软件以外，可能还需要人手变更某些设置，以控制服务器对可疑的域名数据包作出筛选。(参考文献6)  

简单来说，就是DNS查询返回结果的时候，如果有人在查询结果返回之前，给了你一个错误的ip，那么你就永远获取不到那个正确的ip从而无法访问对应的网站或者资源等。  

## 7.Shadowsocks
Shadowsocks（简称SS）是一种基于Socks5代理方式的加密传输协议，也可以指实现这个协议的各种开发包。当前包使用Python、C、C++、C#、Go语言、Rust等编程语言开发，大部分主要实现（iOS平台的除外）采用Apache许可证、GPL、MIT许可证等多种自由软件许可协议开放源代码。Shadowsocks分为服务器端和客户端，在使用之前，需要先将服务器端程序部署到服务器上面，然后通过客户端连接并创建本地代理。(参考文献7)  

Shadowsocks的运行原理与其他代理工具基本相同，使用特定的中转服务器完成数据传输。例如，用户无法直接访问Google，但代理服务器可以访问，且用户可以直接连接代理服务器，那么用户就可以通过特定软件连接代理服务器，然后由代理服务器获取网站内容并回传给用户，从而实现代理上网的效果。另外用户在成功连接到服务器后，客户端会在本机构建一个本地Socks5代理（或VPN、透明代理等）。浏览网络时，网络流量需要先通过本地代理传递到客户端软件，然后才能发送到服务器端，反之亦然。  

为防止流量被识别和拦截，服务器和客户端软件会要求提供密码和加密方式，并且在数据传输期间会对传入和传出流量进行加密。  

## 参考文献:
1.https://zh.wikipedia.org/wiki/%E8%99%9B%E6%93%AC%E7%A7%81%E4%BA%BA%E7%B6%B2%E8%B7%AF  
2.https://zh.wikipedia.org/wiki/%E9%9A%A7%E9%81%93%E5%8D%8F%E8%AE%AE  
3.https://zh.wikipedia.org/wiki/%E8%99%9A%E6%8B%9F%E4%B8%93%E7%94%A8%E6%9C%8D%E5%8A%A1%E5%99%A8  
4.https://zh.wikipedia.org/wiki/%E5%8F%8D%E5%90%91%E4%BB%A3%E7%90%86  
5.https://pino-hd.github.io/2018/06/10/DNS%E5%8A%AB%E6%8C%81%E4%B8%8EDNS%E6%B1%A1%E6%9F%93/  
6.https://zh.wikipedia.org/wiki/%E5%9F%9F%E5%90%8D%E6%9C%8D%E5%8A%A1%E5%99%A8%E7%BC%93%E5%AD%98%E6%B1%A1%E6%9F%93]  
7.https://zh.wikipedia.org/wiki/Shadowsocks  